package com.xueyi.system.digitalmans.controller;

import com.xueyi.common.core.web.result.AjaxResult;
import com.xueyi.common.core.web.result.R;
import com.xueyi.common.core.web.validate.V_A;
import com.xueyi.common.core.web.validate.V_E;
import com.xueyi.common.log.annotation.Log;
import com.xueyi.common.log.enums.BusinessType;
import com.xueyi.common.security.annotation.Logical;
import com.xueyi.common.security.annotation.RequiresPermissions;
import com.xueyi.common.web.entity.controller.BaseController;
import com.xueyi.system.api.digitalmans.domain.vo.DmReceptionVo;
import com.xueyi.system.digitalmans.domain.dto.DmDigitalmanDto;
import com.xueyi.system.digitalmans.domain.dto.DmReceptionDto;
import com.xueyi.system.digitalmans.domain.query.DmDigitalmanQuery;
import com.xueyi.system.digitalmans.domain.query.DmReceptionQuery;
import com.xueyi.system.digitalmans.service.IDmDigitalmanService;
import com.xueyi.system.digitalmans.service.IDmReceptionService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.*;

import java.io.Serializable;
import java.util.List;

/**
 * 接待模式管理管理 业务处理
 *
 * @author yinruoxi
 */
@RestController
@RequestMapping("/reception")
public class DmReceptionController extends BaseController<DmReceptionQuery, DmReceptionDto, IDmReceptionService> {

    @Autowired
    private IDmDigitalmanService digitalmanService;

    /** 定义节点名称 */
    @Override
    protected String getNodeName() {
        return "接待模式管理" ;
    }


    @GetMapping("/inner/get_reception_task")
    public R<DmReceptionVo> getReceptionTaskInner(@RequestParam("manCode") String manCode) {
        DmDigitalmanQuery query = new DmDigitalmanQuery();
        query.setManCode(manCode);
        List<DmDigitalmanDto> manList = digitalmanService.selectList(query);
        DmReceptionVo res = baseService.selectReceptionTask(manList.get(0).getId());
        if (res == null) {
            return R.fail("未查询到接待模式");
        }
        return R.ok(res);
    }

    /**
     * 查询接待模式管理列表
     */
    @Override
    @GetMapping("/list")
    @RequiresPermissions(Auth.DM_RECEPTION_LIST)
    public AjaxResult list(DmReceptionQuery reception) {
        return super.list(reception);
    }

    /**
     * 查询接待模式管理详细
     */
    @Override
    @GetMapping(value = "/{id}")
    @RequiresPermissions(Auth.DM_RECEPTION_SINGLE)
    public AjaxResult getInfo(@PathVariable Serializable id) {
        return super.getInfo(id);
    }

    /**
     * 接待模式管理新增
     */
    @Override
    @PostMapping
    @RequiresPermissions(Auth.DM_RECEPTION_ADD)
    @Log(title = "接待模式管理管理", businessType = BusinessType.INSERT)
    public AjaxResult add(@Validated({V_A.class}) @RequestBody DmReceptionDto reception) {
        return super.add(reception);
    }

    /**
     * 接待模式管理修改
     */
    @Override
    @PutMapping
    @RequiresPermissions(Auth.DM_RECEPTION_EDIT)
    @Log(title = "接待模式管理管理", businessType = BusinessType.UPDATE)
    public AjaxResult edit(@Validated({V_E.class}) @RequestBody DmReceptionDto reception) {
        return super.edit(reception);
    }


    /**
     * 接待模式管理修改状态
     */
    @Override
    @PutMapping("/status")
    @RequiresPermissions(value = {Auth.DM_RECEPTION_EDIT, Auth.DM_RECEPTION_ES}, logical = Logical.OR)
    @Log(title = "接待模式管理管理", businessType = BusinessType.UPDATE_STATUS)
    public AjaxResult editStatus(@RequestBody DmReceptionDto reception) {
        return super.editStatus(reception);
    }

    /**
     * 接待模式管理批量删除
     */
    @Override
    @DeleteMapping("/batch/{idList}")
    @RequiresPermissions(Auth.DM_RECEPTION_DEL)
    @Log(title = "接待模式管理管理", businessType = BusinessType.DELETE)
    public AjaxResult batchRemove(@PathVariable List<Long> idList) {
        return super.batchRemove(idList);
    }

    /**
     * 获取接待模式管理选择框列表
     */
    @Override
    @GetMapping("/option")
    public AjaxResult option() {
        return super.option();
    }

    interface Auth {
        /** 系统 - 接待模式管理管理 - 列表 */
        String DM_RECEPTION_LIST = "digitalmans:reception:list";
        /** 系统 - 接待模式管理管理 - 详情 */
        String DM_RECEPTION_SINGLE = "digitalmans:reception:single";
        /** 系统 - 接待模式管理管理 - 新增 */
        String DM_RECEPTION_ADD = "digitalmans:reception:add";
        /** 系统 - 接待模式管理管理 - 修改 */
        String DM_RECEPTION_EDIT = "digitalmans:reception:edit";
        /** 系统 - 接待模式管理管理 - 修改状态 */
        String DM_RECEPTION_ES = "digitalmans:reception:es";
        /** 系统 - 接待模式管理管理 - 删除 */
        String DM_RECEPTION_DEL = "digitalmans:reception:delete";
    }
}
